<?php include("logincheck.php") ?>
<?php
				
		echo '<style type="text/css">';
			echo ' table.phpsafe { background-color: #000000; } ';
			echo ' td.p_left { background-color: #CCCCFF; } ';
			echo ' td.p_right { background-color: #CCCCCC; } ';
			echo ' td.p_top { background-color: #9999CC; } ';
			echo ' td.p_top h1#php { font-size: 130%; color: #000000; font-weight: bold; } ';
			echo ' td.phpsafe { background-color: #F5F5FA; } ';
			echo ' span.red { background-color: #EE0000; color: #FFFFFF; font-weight: bold; } ';
			echo ' span.green { background-color: #00EE00; color: #FFFFFF; font-weight: bold; } ';
			echo ' span.yellow { background-color: #EEDD00; color: #FFFFFF; font-weight: bold; } ';
			echo ' small.orange { color: #DB5902; } ';
		echo '</style>';
		
		// Funktion zum Ausgeben der Server API
		function return_server_api()
		{
			$string = PHP_SAPI; // String PHP_SAPI auslesen
			$newstring = ''; // String, der zurckgegeben wird (nur bei "apache")
			if(substr($string, 0, 6) == 'apache') // falls die Server API ein Apache ist
			{
				$newstring .= 'Apache '; $i = 6; // Apache groschreiben und Zhlvariable $i anpassen
				// Nun die Versionsnummer (falls vorhanden) auslesen, solange bis ein anderes Zeichen als
				// eine Zahl von 0-9 oder . oder _ auftaucht
				while(eregi("^[0-9._]$", substr($string, $i, 1)))
				{
					// Zahl an $newstring dranhngen und _ mit . ersetzen
					$newstring .= str_replace('_', '.', substr($string, $i, 1)); $i++;
				}
				// Leerzeichen und nchstes Wort (eventuell "filter" oder "handler") Groschreiben (erster Buchstabe)
				$newstring .= ' '.strtoupper(substr($string, $i, 1)); $i++;
				$newstring .= substr($string, $i, (strlen($string) - $i)); // Jetzt den Rest dranhngen und zurckgeben
				return $newstring;
			}
			if($string == 'aolserver') return 'AOLserver'; // AOLserver
			else if($string == 'webjames ') return 'WebJames'; // WebJames
			else if($string == 'cgi-fcgi') return 'CGI / FastCFI'; // CGI / FastCGI
			else if($string == 'cgi') return 'CGI PHP'; // CGI-API
			else if($string == 'cli') return 'CLI PHP'; // CLI-API
			else if($string == 'milter') return 'Sendmail Milter'; // Sendmail Milter
			else if(eregi("^([0-9a-z._]+)sapi([0-9a-z._]+)$", $string)) return str_replace('_', ' ', strtoupper($string)); // Ansonsten prfen, ob es %SAPI% ist und wenn ja, groschreiben alles
			else return strtoupper(substr($string, 0, 1)).substr($string, 1, (strlen($string)-1)); // Ansonsten nur den ersten Buchstaben groschreiben und dann ausgeben
		}
		// Tabelle mit Allgemeinen Daten zum Webserver bzw. PHP
		echo '<table cellpadding="5" cellspacing="1" border="0" style="width: 570px" class="phpsafe">';
		echo '<colgroup> <col width="240px"> <col> </colgroup> <tr>';
			echo '<td class="p_top" colspan="2"><a href="http://www.php.net/"><img border="0" src="php.php?='.php_logo_guid().'" alt="PHP Logo" style="float: right; border: 0px"></a><h1 id="php">PHP / Webserver</h1></td>';
		echo '</tr><tr>'; // PHP-Version
			echo '<td class="p_left"><b>PHP-Version</b></td><td class="p_right">'.phpversion().'</td>';
		echo '</tr><tr>'; // Betriebssystem
			echo '<td class="p_left"><b>System</b></td><td class="p_right">'.php_uname().'</td>';
		echo '</tr><tr>'; // Server API (siehe Funktion)
			echo '<td class="p_left"><b>Server API</b></td><td class="p_right">'.return_server_api().'</td>';
		echo '</tr><tr>'; // Zend-Version (PHP-Parser)
			echo '<td class="p_left"><b>Zend Version</b></td><td class="p_right">'.zend_version().'</td>';
		echo '</tr><tr>'; // Version dieses Gstebuchs
			echo '<td class="p_left"><b>Gstebuchversion</b></td><td class="p_right">'.$gbversion.'</td>';
		echo '</tr></table><br><br>';
		// Tabelle mit PHP-Konfiguration
		echo '<table cellpadding="2" cellspacing="1" border="0" style="width: 570px" class="phpsafe">';
		echo '<colgroup> <col width="345px"> <col width="110px"> <col width="110px"> </colgroup>';
		echo '<tr>';
			echo '<td class="phpsafe"><b>Konfiguration</b></td>'; // Name und Beschreibung
			echo '<td class="phpsafe"><b>Status</b></td>'; // Aktueller Status
			echo '<td class="phpsafe"><b>Empfohlen</b></td>'; // Empfohlener Status
		echo '</tr>';
		// Funktion zum Auswerten der Fehler-Einstellungen (es wird nur ein Integer-Wert zurckgegeben)
		function get_error_report($int)
		{
			$php_version = phpversion(); // PHP-Version auslesen
			$error_values = array(0, 1, 2, 4, 8, 16, 32, 64, 128, 256, 512, 1024, 2047, 2048, 6143); // Integer-Werte der Fehler
			// Namen der Fehler
			$error_names = array(0 => 'E_NONE', 1 => 'E_ERROR', 2 => 'E_WARNING', 4 => 'E_PARSE', 8 => 'E_NOTICE', 16 => 'E_CORE_ERROR', 32 => 'E_CORE_WARNING', 64 => 'E_COMPILE_ERROR', 128 => 'E_COMPILE_WARNING', 256 => 'E_USER_ERROR', 512 => 'E_USER_WARNING', 1024 => 'E_USER_NOTICE', 6143 => 'E_ALL', 2048 => 'E_STRICT');
			// Schleife zum berprfen, ob $int direkt einem Error-Typ entspricht
			for($a = 0; $a < count($error_values); $a++) {
				if($int == $error_values[$a]) {
					if($error_values[$a] == 2048 and version_compare($php_version, '5.0.0.', '>=') == 1) return 'E_STRICT'; // E_STRICT gibt es erst ab PHP 5.0.0
					else if($error_values[$a] == 6143 and sversion_compare($php_version, '5.0.0.', '>=') == 1) return 'E_ALL'; // E_ALL mit 6143 gibt es ab PHP 5.0.0
					else if($error_values[$a] == 2047) return 'E_ALL'; // Vorher hatte E_ALL 2047
					else return $error_names[$error_values[$a]]; // Ansonsten direkt den Fehler ausgeben
				}
			}
			$counter = 0; $i = count($error_values) - 2; // Zhlvariable und Counter
			if(version_compare($php_version, '5.0.0.', '<') == 1) {
				$e_all = 2047; $i = $i - 2; // E_ALL hat den Wert 2047, falls PHP-Version < 5.0.0
			}
			else $e_all = 6143; // Ansonsten 6143
			while($counter != $int) { // Solange der Wert des Counters nicht dem vorhandenen Wert entspricht
				$counter = $e_all - $error_values[$i]; // Wert aller Fehler von E_ALL nacheinander abziehen
				if($i == 0) break; // Falls $i 0 erreicht hat, Schleife abbrechen
				if($counter != $int) $i--; // Solange der Counter nicht dem Wert entspricht, $i runtersetzen
				else break; // Ansonsten aufhren
			}
			// Sollte $counter dem Wert entsprechen, den aktuellen Wert der Fehlermeldung ausgeben mit E_ALL
			if($counter == $int) return 'E_ALL & ~'.$error_names[$error_values[$i]];				
		}
		
		// Ab hier berprfung der westentlichen PHP-Einstellungen
		$php_config = array();
		
		function get_ini_config($ini_option)
		{
			$value = get_cfg_var($ini_option);
			if($value == '') $value = "0";
			return $value;
		}
		
		$thislanguage = array();
		$thislanguage['value_1'] = 'Aktiviert';
		$thislanguage['value_0'] = 'Deaktiviert';
		$thislanguage['value_'] = 'Unbekannt';

		$php_config['allow_url_fopen'] = get_ini_config('allow_url_fopen'); // Empfohlen: 1 = On
		$php_config['error_reporting'] = get_ini_config('error_reporting'); // Empfohlen: -
		$php_config['file_uploads'] = get_ini_config('file_uploads'); // Empfohlen: 1 = On
		$php_config['magic_quotes_gpc'] = get_ini_config('magic_quotes_gpc'); // Empfohlen: 1 = On
		$php_config['max_execution_time'] = get_ini_config('max_execution_time'); // Empfohlen: < 60 Sekunden
		$php_config['output_buffering'] = get_ini_config('output_buffering'); // Empfohlen: 0 = Off
		$php_config['register_globals'] = get_ini_config('register_globals'); // Empfohlen: 0 = Off
		$php_config['register_long_arrays'] = get_ini_config('register_long_arrays'); // Empfohlen: 0 = Off
		$php_config['safe_mode'] = get_ini_config('safe_mode'); // Empfohlen: 1 = On
		$php_config['session.use_trans_sid'] = get_ini_config('session.use_trans_sid'); // Empfohlen: 0 = Off
		$php_config['short_open_tag'] = get_ini_config('short_open_tag'); // Empfohlen: 0 = Off
		$php_config['upload_max_filesize'] = get_ini_config('upload_max_filesize'); // Empfohlen: -
		
		// Ausgabe des Status fr "allow_url_fopen"
		echo '<tr><td class="phpsafe">allow_url_fopen<br><small class="orange">'.$thislanguage['allow_url_fopen'].'</small></td>';
			echo '<td class="phpsafe" align="center">';
				if($php_config['allow_url_fopen'] == "0") echo '<span class="red">';
				else if($php_config['allow_url_fopen'] == "1") echo '<span class="green">';
				else echo '<span class="yellow">';
			echo $thislanguage['value_'.$php_config['allow_url_fopen']].'</span></td>';
			echo '<td class="phpsafe" align="center">'.$thislanguage['value_1'].'</td></tr>';
		// Ausgabe des Status fr "error_reporting"
		echo '<tr><td class="phpsafe">error_reporting<br><small class="orange">'.$thislanguage['error_reporting'].'</small></td>';
			echo '<td class="phpsafe" align="center">';
				$error_reporting_status = get_error_report($php_config['error_reporting']);
				if(substr($error_reporting_status, 0, 5) == 'E_ALL') echo '<span class="green">';
				else if($error_reporting_status == 'E_NONE') echo '<span class="red">';
				else echo '<span class="yellow">';
				if($error_reporting_status == '') echo $thislanguage['value_'].'</span>';
				else echo $error_reporting_status.'</span></td>';
			echo '<td class="phpsafe" align="center">-</td></tr>';
		// Ausgabe des Status fr "file_uploads"
		echo '<tr><td class="phpsafe">file_uploads<br><small class="orange">'.$thislanguage['file_uploads'].'</small></td>';
			echo '<td class="phpsafe" align="center">';
				if($php_config['file_uploads'] == "0") echo '<span class="red">';
				else if($php_config['file_uploads'] == "1") echo '<span class="green">';
				else echo '<span class="yellow">';
			echo $thislanguage['value_'.$php_config['file_uploads']].'</span></td>';
			echo '<td class="phpsafe" align="center">'.$thislanguage['value_1'].'</td></tr>';
		// Ausgabe des Status fr "magic_quotes_gpc"
		echo '<tr><td class="phpsafe">magic_quotes_gpc<br><small class="orange">'.$thislanguage['magic_quotes_gpc'].'</small></td>';
			echo '<td class="phpsafe" align="center">';
				if($php_config['magic_quotes_gpc'] == "1") echo '<span class="red">';
				else if($php_config['magic_quotes_gpc'] == "0") echo '<span class="green">';
				else echo '<span class="yellow">';
			echo $thislanguage['value_'.$php_config['magic_quotes_gpc']].'</span></td>';
			echo '<td class="phpsafe" align="center">'.$thislanguage['value_0'].'</td></tr>';
		// Ausgabe des Status fr "max_execution_time"
		echo '<tr><td class="phpsafe">max_execution_time<br><small class="orange">'.$thislanguage['max_execution_time'].'</small></td>';
			echo '<td class="phpsafe" align="center">';
				if($php_config['max_execution_time'] > "60") echo '<span class="red">';
				else if($php_config['max_execution_time'] <= "60") echo '<span class="green">';
				else echo '<span class="yellow">';
			echo ' &nbsp; '.$php_config['max_execution_time'].'s &nbsp; </span></td>';
			echo '<td class="phpsafe" align="center">< 60s</td></tr>';
		// Ausgabe des Status fr "output_buffering"
		echo '<tr><td class="phpsafe">output_buffering<br><small class="orange">'.$thislanguage['output_buffering'].'</small></td>';
			echo '<td class="phpsafe" align="center">';
				if($php_config['output_buffering'] == "1") echo '<span class="red">';
				else if($php_config['output_buffering'] == "0") echo '<span class="green">';
				else echo '<span class="yellow">';
			echo $thislanguage['value_'.$php_config['output_buffering']].'</span></td>';
			echo '<td class="phpsafe" align="center">'.$thislanguage['value_0'].'</td></tr>';
		// Ausgabe des Status fr "register_globals"
		echo '<tr><td class="phpsafe">register_globals<br><small class="orange">'.$thislanguage['register_globals'].'</small></td>';
			echo '<td class="phpsafe" align="center">';
				if($php_config['register_globals'] == "1") echo '<span class="red">';
				else if($php_config['register_globals'] == "0") echo '<span class="green">';
				else echo '<span class="yellow">';
			echo $thislanguage['value_'.$php_config['register_globals']].'</span></td>';
			echo '<td class="phpsafe" align="center">'.$thislanguage['value_0'].'</td></tr>';
		// Ausgabe des Status fr "register_long_arrays"
		echo '<tr><td class="phpsafe">register_long_arrays<br><small class="orange">'.$thislanguage['register_long_arrays'].'</small></td>';
			echo '<td class="phpsafe" align="center">';
				if($php_config['register_long_arrays'] == "1") echo '<span class="red">';
				else if($php_config['register_long_arrays'] == "0") echo '<span class="green">';
				else echo '<span class="yellow">';
			echo $thislanguage['value_'.$php_config['register_long_arrays']].'</span></td>';
			echo '<td class="phpsafe" align="center">'.$thislanguage['value_0'].'</td></tr>';
		// Ausgabe des Status fr "safe_mode"
		echo '<tr><td class="phpsafe">safe_mode<br><small class="orange">'.$thislanguage['safe_mode'].'</small></td>';
			echo '<td class="phpsafe" align="center">';
				if($php_config['safe_mode'] == "0") echo '<span class="red">';
				else if($php_config['safe_mode'] == "1") echo '<span class="green">';
				else echo '<span class="yellow">';
			echo $thislanguage['value_'.$php_config['safe_mode']].'</span></td>';
			echo '<td class="phpsafe" align="center">'.$thislanguage['value_1'].'</td></tr>';
		// Ausgabe des Status fr "session.use_trans_sid"
		echo '<tr><td class="phpsafe">session.use_trans_sid<br><small class="orange">'.$thislanguage['session.use_trans_sid'].'</small></td>';
			echo '<td class="phpsafe" align="center">';
				if($php_config['session.use_trans_sid'] == "1") echo '<span class="red">';
				else if($php_config['session.use_trans_sid'] == "0") echo '<span class="green">';
				else echo '<span class="yellow">';
			echo $thislanguage['value_'.$php_config['session.use_trans_sid']].'</span></td>';
			echo '<td class="phpsafe" align="center">'.$thislanguage['value_0'].'</td></tr>';
		// Ausgabe des Status fr "short_open_tag"
		echo '<tr><td class="phpsafe">short_open_tag<br><small class="orange">'.$thislanguage['short_open_tag'].'</small></td>';
			echo '<td class="phpsafe" align="center">';
				if($php_config['short_open_tag'] == "1") echo '<span class="red">';
				else if($php_config['short_open_tag'] == "0") echo '<span class="green">';
				else echo '<span class="yellow">';
			echo $thislanguage['value_'.$php_config['short_open_tag']].'</span></td>';
			echo '<td class="phpsafe" align="center">'.$thislanguage['value_0'].'</td></tr>';
		// Ausgabe des Status fr "short_open_tag"
		echo '<tr><td class="phpsafe">upload_max_filesize<br><small class="orange">'.$thislanguage['upload_max_filesize'].'</small></td>';
			echo '<td class="phpsafe" align="center">'.$php_config['upload_max_filesize'].'</span></td>';
			echo '<td class="phpsafe" align="center">-</td></tr>';

		echo '</table><br><br>';
		
		$loaded_extensions = get_loaded_extensions();
		echo '<div style="padding: 4px; border: 1px solid #000000; width: 565px"><b>'.$thislanguage['php_erweiterungen'].'</b><br>';
		for($a = 0; $a < count($loaded_extensions); $a++)
		{
			echo $loaded_extensions[$a];
			if($a < ( count($loaded_extensions) - 1)) echo ', ';
		}
		echo '</div><br><br>';
?>